﻿using UnityEngine;
using System.Collections;

public class TileScript : MonoBehaviour {

	public TileMap MainScript;
	public GameObject TileObj;
	public SpriteRenderer TileGraphObj;
	public int PosX;
	public int PosY;
	public MoveDir TryMotionDir = MoveDir.None;
	public GraphConnect Connections;
	public bool IsStar = false;
	public bool IsEnergy = false;
	public bool IsMouseOver = false;
	public float TimeLastBlock = 0.0f;
	public float TimeLastEnUp = 0.0f;
	public float TimeLastEnDown = 0.0f;
	public bool HadEnergy = false;

	public GameObject[] RedWarn = new GameObject[7];

	Vector2 StartDragMousePos;
	//float NextRequestTime = 0.0f;

	// Use this for initialization
	void Start () {

	}
	
	// Update is called once per frame
	void Update () {
	}
	/*
	void OnMouseEnter() {
		if (IsStar) {
			IsMouseOver = true;
		}
	}

	void OnMouseExit() {
		if (IsStar) {
			IsMouseOver = false;
		}
	}

	void OnMouseDown  () {
		if (IsStar) {
			StartDragMousePos = Input.mousePosition;
			NextRequestTime = 0.0f;
		}
	}

	void OnMouseDrag () {
		if (!IsStar) {
			return;
		}
		Vector2 MousePosition = Input.mousePosition;
		Vector2 DragDir = MousePosition - StartDragMousePos;
		if (DragDir.magnitude > 20.0f) {
			float CurrentTime = Time.fixedTime;
			if(CurrentTime > NextRequestTime) {

				NextRequestTime = CurrentTime + 100000.0f;

				DragDir.Normalize();
				MainScript.RequestMoveTile (this, DragDir, false );
			}
		}
	}*/

	public void TriggerBlock() {
		TimeLastBlock = 1.0f;
	}

	public void Tick() {
		if(TimeLastBlock > 0.0f) TimeLastBlock -= Time.fixedDeltaTime * 3.0f;
		if(TimeLastEnUp > 0.0f) TimeLastEnUp -= Time.fixedDeltaTime;
		if(TimeLastEnDown > 0.0f) TimeLastEnDown -= Time.fixedDeltaTime;

		SpriteRenderer SR = renderer as SpriteRenderer;

		Color Red = new Color (1.0f, 0.0f, 0.0f);
		Color Green = new Color (0.0f, 1.0f, 0.0f);

		Color NewColor = (IsEnergy) ? Green : Red;
		if(MainScript.IsWinState()) {
			NewColor = Color.Lerp(NewColor, new Color (1.0f, 1.0f,0.0f), 1.0f-MainScript.TimeBlackScreen);
		}
		if(TileGraphObj != null) {
			TileGraphObj.color = NewColor;
		}

		if (IsEnergy != HadEnergy) {
			if(IsEnergy) {
				TimeLastEnUp = 1.0f;
				TimeLastEnDown = 0.0f;
			} else {
				TimeLastEnUp = 0.0f;
				TimeLastEnDown = 1.0f;
			}
			HadEnergy = IsEnergy;
		}


		Color BaseColor = new Color (0.3f, 0.0f, 1.0f);

		if (!IsStar) {
			BaseColor = new Color (0.1f, 0.0f, 0.5f);
		}

		if (IsMouseOver) {
			BaseColor = Color.Lerp(BaseColor, new Color (1.0f, 1.0f,1.0f), 0.9f);
		}

		if (TimeLastBlock > 0.0f) {
			BaseColor = Color.Lerp(BaseColor, new Color (1.0f, 1.0f,0.2f), TimeLastBlock);
		} else if (TimeLastEnUp > 0.0f) {
			BaseColor = Color.Lerp(BaseColor, new Color (0.0f, 1.0f,0.0f), TimeLastEnUp);
		} else if (TimeLastEnDown > 0.0f) {
			BaseColor = Color.Lerp(BaseColor, new Color (1.0f, 0.0f,0.0f), TimeLastEnDown);
		} else {
			//SR.color = new Color (0.4f, 0.4f, 1.0f);
		}

		SR.color = BaseColor;
	}
}
